function [codelen] = q1_b(D)

    if not (isrow(D))
        error('D must be a row vector');
    end

    codelen = 1;

    a = 0.5;
    b = 0.5;

    n = [ 0, 0 ];
    k = [ 0, 0 ];

    prev = D(1) + 1;
    for x = D(2:end)
        if x == 0
            p = (a + k(prev)) / (a + b + n(prev));
            k(prev) = k(prev) + 1;
        elseif x == 1
            p = (b + (n(prev) - k(prev))) / (a + b + n(prev));
        else
            error('Non-binary value in D');
        end
        
        n(prev) = n(prev) + 1;
        prev = x + 1;
        codelen = codelen + log2(1/p);
    end

end