function [codelen] = q1_a(D)

    if not (isrow(D))
        error('D must be a row vector');
    end

    codelen = 0;

    a = 0.5;
    b = 0.5;
    n = 0;
    k = 0;

    for x = D
        if x == 0
            p = (a + k) / (a + b + n);
            k = k + 1;
        elseif x == 1
            p = (b + (n - k)) / (a + b + n);
        else
            error('Non-binary value in D');
        end
        
        n = n + 1;
        codelen = codelen + log2(1/p);
    end

end