function [codelen] = q1_c(D)

    if not (isrow(D))
        error('D must be a row vector');
    end

    codelen = 2;

    a = 0.5;
    b = 0.5;

    n = [ 0, 0, 0, 0 ];
    k = [ 0, 0, 0, 0 ];

    for i = 3:length(D)
        prev = 2 * D(i-2) + D(i-1) + 1;
        x = D(i);

        if x == 0
            p = (a + k(prev)) / (a + b + n(prev));
            k(prev) = k(prev) + 1;
        elseif x == 1
            p = (b + (n(prev) - k(prev))) / (a + b + n(prev));
        else
            error('Non-binary value in D');
        end
        
        n(prev) = n(prev) + 1;
        codelen = codelen + log2(1/p);
    end

end