function [codelen] = q2_o0(D)

    if not (isrow(D))
        error('D must be a row vector');
    end
    
    n = length(D);
    k = n - sum(D);
    
    theta = k / n;
    
    log2p = k*log2(theta) + (n-k)*log2(1-theta);
    log2C = log2(q2_nml_constant(n));
    codelen = -(log2p - log2C);
    
end